- Main Page
- Namespaces
- Data Structures
- Files

- File List
- Globals

# libiscsi.c File Reference

`#include <stdio.h>`
`#include <stdlib.h>`
`#include <string.h>`
`#include <errno.h>`
`#include <unistd.h>`
`#include <sys/syslog.h>`
`#include "libiscsi.h"`
`#include "idbm.h"`
`#include "discovery.h"`
`#include "log.h"`
`#include "sysfs.h"`
`#include "iscsi_sysfs.h"`
`#include "session_info.h"`
`#include "iscsi_util.h"`
`#include "sysdeps.h"`
`#include "iface.h"`
`#include "iscsi_proto.h"`
`#include "fw_context.h"`
`#include "iscsid_req.h"`
`#include "iscsi_err.h"`

## Data Structures
struct | libiscsi_context
## Defines
#define | CHECK(a) { context->error_str[0] = 0; rc = a; if (rc) goto leave; }
## Functions
libiscsi_context * | libiscsi_init (void)
| Initalize libiscsi.
void | libiscsi_cleanup (struct libiscsi_context *context)
| Cleanup libiscsi used resource.
int | libiscsi_discover_sendtargets (struct libiscsi_context *context, const char *address, int port, const struct libiscsi_auth_info *auth_info, int *nr_found, struct libiscsi_node **found_nodes)
| Discover iSCSI nodes using sendtargets and add them to the node db.
int | libiscsi_discover_firmware (struct libiscsi_context *context, int *nr_found, struct libiscsi_node **found_nodes)
| Read iSCSI node info from firmware and add them to the node db.
int | libiscsi_verify_auth_info (struct libiscsi_context *context, const struct libiscsi_auth_info *auth_info)
| Check validity of the given authentication info.
int | libiscsi_node_set_auth (struct libiscsi_context *context, const struct libiscsi_node *node, const struct libiscsi_auth_info *auth_info)
| Set the authentication info for the given node.
int | libiscsi_node_get_auth (struct libiscsi_context *context, const struct libiscsi_node *node, struct libiscsi_auth_info *auth_info)
| Get the authentication info for the given node.
int | login_helper (void *data, node_rec_t *rec)
int | libiscsi_node_login (struct libiscsi_context *context, const struct libiscsi_node *node)
| Login to an iSCSI node.
int | libiscsi_node_logout (struct libiscsi_context *context, const struct libiscsi_node *node)
| Logout of an iSCSI node.
int | libiscsi_node_set_parameter (struct libiscsi_context *context, const struct libiscsi_node *node, const char *parameter, const char *value)
| Set an iSCSI parameter for the given node.
int | libiscsi_node_get_parameter (struct libiscsi_context *context, const struct libiscsi_node *node, const char *parameter, char *value)
| Get the value of an iSCSI parameter for the given node.
const char * | libiscsi_get_error_string (struct libiscsi_context *context)
| Get human readable string describing the last libiscsi error.
int | libiscsi_get_firmware_network_config (struct libiscsi_network_config *config)
| Get network configuration information from iscsi firmware.
int | libiscsi_get_firmware_initiator_name (char *initiatorname)
| Get the initiator name (iqn) from the iscsi firmware.

## Define Documentation

#define CHECK | ( | a |  | ) | { context->error_str[0] = 0; rc = a; if (rc) goto leave; }

## Function Documentation

void libiscsi_cleanup | ( | struct libiscsi_context * | context | ) |

This function cleanups any used resources and then destroys the passed context. After this the passed in context may no longer be used!

Parameters:

  | context | libiscsi context to operate on.

int libiscsi_discover_firmware | ( | struct libiscsi_context * | context,
|  | int * | nr_found,
|  | struct libiscsi_node ** | found_nodes |
| ) |  |  |

This function discovers iSCSI nodes using firmware (ppc or ibft). Any found nodes are added to the local iSCSI node database and are returned in a dynamically allocated array.

Note that unlike sendtargets discovery, this function will also read authentication info and store that in the database too.

Note this function currently is a stub which will always return -EINVAL (IOW it is not yet implemented)

Parameters:

  | context | libiscsi context to operate on.
  | nr_found | The number of found nodes will be returned through this pointer if not NULL.
  | found_nodes | The address of the dynamically allocated array of found nodes will be returned through this pointer if not NULL. The caller must free this array using free().

Returns:
  0 on success, otherwise a standard error code (from errno.h).

int libiscsi_discover_sendtargets | ( | struct libiscsi_context * | context,
|  | const char * | address,
|  | int | port,
|  | const struct libiscsi_auth_info * | auth_info,
|  | int * | nr_found,
|  | struct libiscsi_node ** | found_nodes |
| ) |  |  |

This function connects to the given address and port and then tries to discover iSCSI nodes using the sendtargets protocol. Any found nodes are added to the local iSCSI node database and are returned in a dynamically allocated array.

Note that the (optional) authentication info is for authenticating the discovery, and is not for the found nodes! If the connection(s) to the node(s) need authentication too, you can set the username / password for those (which can be different!) using the libiscsi_node_set_auth() function.

Parameters:

  | context | libiscsi context to operate on.
  | address | Hostname or IP-address to connect to.
  | port | Port to connect to, or 0 for the default port.
  | auth_info | Authentication information, or NULL.
  | nr_found | The number of found nodes will be returned through this pointer if not NULL.
  | found_nodes | The address of the dynamically allocated array of found nodes will be returned through this pointer if not NULL. The caller must free this array using free().

Returns:
  0 on success, otherwise a standard error code (from errno.h).

const char* libiscsi_get_error_string | ( | struct libiscsi_context * | context | ) |

This function can be called to get a human readable error string when a libiscsi function has returned an error. This function uses a single buffer per context, thus the result is only valid as long as no other libiscsi calls are made on the same context after the failing function call.

Parameters:

  | context | libiscsi context to operate on.

Returns:
  human readable string describing the last libiscsi error.

int libiscsi_get_firmware_initiator_name | ( | char * | initiatorname | ) |

Get the initiator name (iqn) from the iscsi firmware.

Parameters:

  | initiatorname | The initiator name is stored here, this buffer must be atleast LIBISCSI_VALUE_MAXLEN bytes large.

Returns:
  0 on success, ENODEV when no iscsi firmware was found.

int libiscsi_get_firmware_network_config | ( | struct libiscsi_network_config * | config | ) |

Function can be called to get the network configuration information (like dhcp, ip, netmask, default gateway, etc.) from the firmware of a network adapter with iscsi boot firmware.

Note that not all fields of the returned struct are necessarilly filled, unset fields contain a 0 length string.

Parameters:

  | config | pointer to a libiscsi_network_config struct to fill.

Returns:
  0 on success, ENODEV when no iscsi firmware was found.

struct libiscsi_context* libiscsi_init | ( | void |  | ) |

This function creates a libiscsi context and initalizes it. This context is need to use other libiscsi funtions.

Returns:
  A pointer to the created context, or NULL in case of an error.

int libiscsi_node_get_auth | ( | struct libiscsi_context * | context,
|  | const struct libiscsi_node * | node,
|  | struct libiscsi_auth_info * | auth_info |
| ) |  |  |

This function gets the authentication information for the node described by the given node record.

Parameters:

  | context | libiscsi context to operate on.
  | node | iSCSI node to set auth information of
  | auth_info | Pointer to a libiscsi_auth_info struct where the retreived information will be stored.

Returns:
  0 on success, otherwise a standard error code (from errno.h).

int libiscsi_node_get_parameter | ( | struct libiscsi_context * | context,
|  | const struct libiscsi_node * | node,
|  | const char * | parameter,
|  | char * | value |
| ) |  |  |

Get the value of the given nodes iSCSI parameter named by parameter.

Parameters:

  | context | libiscsi context to operate on.
  | node | iSCSI node to change a parameter from.
  | parameter | Name of the parameter to get.
  | value | The retreived value is stored here, this buffer must be atleast LIBISCSI_VALUE_MAXLEN bytes large.

Returns:
  0 on success, otherwise a standard error code (from errno.h).

int libiscsi_node_login | ( | struct libiscsi_context * | context,
|  | const struct libiscsi_node * | node |
| ) |  |  |

Login to the iSCSI node described by the given node record.

Parameters:

  | context | libiscsi context to operate on.
  | node | iSCSI node to login to.

Returns:
  0 on success, otherwise a standard error code (from errno.h).

int libiscsi_node_logout | ( | struct libiscsi_context * | context,
|  | const struct libiscsi_node * | node |
| ) |  |  |

Logout of the iSCSI node described by the given node record.

Parameters:

  | context | libiscsi context to operate on.
  | node | iSCSI node to logout from.

Returns:
  0 on success, otherwise a standard error code (from errno.h).

int libiscsi_node_set_auth | ( | struct libiscsi_context * | context,
|  | const struct libiscsi_node * | node,
|  | const struct libiscsi_auth_info * | auth_info |
| ) |  |  |

This function sets the authentication information for the node described by the given node record. This will overwrite any existing authentication information.

This is the way to specify authentication information for nodes found through sendtargets discovery.

Note: 1) This is a convience wrapper around libiscsi_node_set_parameter(), setting the node.session.auth.* parameters. 2) For nodes found through firmware discovery the authentication information has already been set from the firmware. 3) auth_info may be NULL in which case any existing authinfo will be cleared.

Parameters:

  | context | libiscsi context to operate on.
  | node | iSCSI node to set auth information of
  | auth_info | Authentication information, or NULL.

Returns:
  0 on success, otherwise a standard error code (from errno.h).

int libiscsi_node_set_parameter | ( | struct libiscsi_context * | context,
|  | const struct libiscsi_node * | node,
|  | const char * | parameter,
|  | const char * | value |
| ) |  |  |

Set the given nodes iSCSI parameter named by parameter to value value.

Parameters:

  | context | libiscsi context to operate on.
  | node | iSCSI node to change a parameter from.
  | parameter | Name of the parameter to set.
  | value | Value to set the parameter too.

Returns:
  0 on success, otherwise a standard error code (from errno.h).

int libiscsi_verify_auth_info | ( | struct libiscsi_context * | context,
|  | const struct libiscsi_auth_info * | auth_info |
| ) |  |  |

This function checks the validity of the given authentication info. For example in case of CHAP, if the username and password are not empty.

This function is mainly intended for use by language bindings.

Parameters:

  | context | libiscsi context to operate on.
  | auth_info | Authentication information to check.

Returns:
  0 on success, otherwise EINVAL.

int login_helper | ( | void * | data,
|  | node_rec_t * | rec |
| ) |  |  |